import { Popconfirm, Space } from "antd"
import React from "react"

const columns = (copy: (str: string) => void, edit: (data: any) => void, del: (id: any) => void,weAppList:any[],gzhList:any[]): any => {
    return [
        {
            title: '落地页名称',
            dataIndex: 'sharePageName',
            key: 'sharePageName',
            align: 'center',
            width: 150,
            ellipsis: true
        },
        {
            title: '公众号名称',
            dataIndex: 'mpAppName',
            key: 'mpAppName',
            align: 'center',
            width: 120,
            ellipsis: true
        },
        {
            title: '公众号appId',
            dataIndex: 'mpAppId',
            key: 'mpAppId',
            align: 'center',
            width: 120,
            ellipsis: true
        },
        {
            title: 'title',
            dataIndex: 'title',
            key: 'title',
            align: 'center',
            width: 150,
            ellipsis: true
        },
        {
            title: '落地页地址',
            dataIndex: 'htmlUrl',
            key: 'htmlUrl',
            align: 'center',
            width: 100,
            ellipsis: true,
            render: (a: any) => {
                return <a onClick={() => {
                    copy(a)
                }}>{a}</a>
            }
        },
        {
            title: '关联小程序',
            dataIndex: 'appConfigIdList',
            key: 'appConfigIdList',
            align: 'center',
            width: 100,
            ellipsis: true,
            render: (a: any) => {
                let str = '/'
                a?.forEach((id: any,index:number)=>{
                    weAppList?.forEach(item=>{
                        if(item?.id === id){
                            str+=index === a.length -1 ? item?.appName:item?.appName +','
                        }
                    })
                })
                return str
            }
        },
        {
            title: '使用文章公众号',
            dataIndex: 'articleMpAppId',
            key: 'articleMpAppId',
            align: 'center',
            width: 100,
            ellipsis: true,
            render: (a: any) => {
                let str = '/'
                gzhList?.forEach(gzh=>{
                    if(gzh.appId === a){
                        str = gzh.appName
                    }
                })
                return str
            }
        },
        {
            title: '创建者',
            dataIndex: 'createByName',
            key: 'createByName',
            align: 'center',
            width: 90,
        },
        {
            title: '创建时间',
            dataIndex: 'createTime',
            key: 'createTime',
            align: 'center',
            width: 150,
        },
        {
            title: '更新者',
            dataIndex: 'updateByName',
            key: 'updateByName',
            align: 'center',
            width: 90,
        },
        {
            title: '更新时间',
            dataIndex: 'updateTime',
            key: 'updateTime',
            align: 'center',
            width: 150,
        },
        {
            title: '操作',
            dataIndex: 'action',
            key: 'action',
            align: 'center',
            width: 150,
            render: (a: any, b: any) => {
                return <Space>
                    <a onClick={() => { edit(b) }}>编辑</a>
                    <Popconfirm
                        title={`确定要删除此条落地页吗？`}
                        onConfirm={() => { del(b?.id) }}
                        okText="Yes"
                        cancelText="No"
                    >
                        <a >删除</a>
                    </Popconfirm>

                </Space>
            }
        }
    ]
}
export default columns